// JavaScript Document
//<![CDATA[
var debug=false;
var map;
var routeMarkers=new Array(0);
var clickedLocation;
var infowindow;
var clickedMarker;
var listner; 

//preload image
var pleasewaitimage = new Image(); 
pleasewaitimage.src = "images/loading.gif";

function initialize() 
{
	document.getElementById("msg").innerHTML="<p><img src='images/loading.gif' /><br/>Loading...</p>";
	var latlng = new google.maps.LatLng(0,0);
	//setCursor:'crosshair'
	var myOptions = {zoom:2,center:latlng,mapTypeId:google.maps.MapTypeId.ROADMAP,draggableCursor:'crosshair',mapTypeControlOptions:{style:google.maps.MapTypeControlStyle.DROPDOWN_MENU}};
	map = new google.maps.Map(document.getElementById("map_canvas"),myOptions);
	
	showall();
	// Add a listener for the click event and call getElevation on that location
    listner=google.maps.event.addListener(map, 'click', clickmap);
}

function clickmap(event)
{
	clickedLocation = event.latLng;
	clickedMarker=placeMarker(clickedLocation,"Add a Guestbook Entry");
	clickedMarker.setMap(map);

	infowindow = new google.maps.InfoWindow({
    	content: "<form id='form1' name='form1' method='post' action=''><table><tr><td>Enter your comments and click [Save]:</td></tr><tr><td><textarea name='textarea' id='ta' cols='26' rows='3' ></textarea></td></tr><tr><td align='center'> <input type='button' name='Submit' value='Save' onclick='addentrysubmit();'/> </td></tr></table></form>"
	});
	infowindow.open(map,clickedMarker);
	google.maps.event.removeListener(listner);
}


function placeMarker(location,text) 
{
	var image = new google.maps.MarkerImage('images/stripes.png',
	// This marker is 20 pixels wide by 32 pixels tall.
	new google.maps.Size(20, 34),
	// The origin for this image is 0,0.
	new google.maps.Point(0,0),
	// The anchor for this image is the base of the flagpole at 0,32.
	new google.maps.Point(9, 33));
	var shadow = new google.maps.MarkerImage('images/shadow.png',
	// The shadow image is larger in the horizontal dimension
	// while the position and offset are the same as for the main image.
	new google.maps.Size(28, 22),
	new google.maps.Point(0,0),
	new google.maps.Point(1, 22));

	var marker = new google.maps.Marker({position:location,map:map,shadow:shadow,icon:image,title:text});
	
	return marker;
}

function showall() 
{
  		var xmlHttp;
  		try
    	{
    		// Firefox, Opera 8.0+, Safari
   		 	xmlHttp=new XMLHttpRequest();
    	}
  		catch (e)
    	{
    		// Internet Explorer
    		try
      		{
      			xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
      		}
    		catch (e)
      		{
      			try
        		{
        			xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
        		}
				catch (e)
				{
					alert("Your browser does not support AJAX!");
					return false;
				}
			}
		}
		
		xmlHttp.onreadystatechange=function()
		{
			if(xmlHttp.readyState==4)
			{
				var xml = GXml.parse(xmlHttp.responseText);
				if (debug)
				{
					alert (xmlHttp.responseText);	
				}
				var markers = xml.documentElement.getElementsByTagName("marker");
				for (var i = 0; i < markers.length; i++) 
				{
					var comments = markers[i].getAttribute("comments");
					var id = markers[i].getAttribute("id");
					var latlng = new google.maps.LatLng(parseFloat(markers[i].getAttribute("lng")),parseFloat(markers[i].getAttribute("lat")));
					var marker=placeMarker(latlng,comments);
					marker.setMap(map);
					routeMarkers.push(marker);
				}
				document.getElementById("msg").innerHTML="<p></p>";
			}
		};
	var randomnumber=Math.floor(Math.random()*9999);
	xmlHttp.open("GET","findgbentries.php?rn="+randomnumber,true);
	xmlHttp.send(null);
}

function addentrysubmit() 
{
	document.getElementById("msg").innerHTML="<p>Thank You.</p>";
	var text_val=document.getElementById("ta").value;
	var lng=clickedLocation.lng();
	var lat=clickedLocation.lat();
	saveentry(text_val,lng,lat);		
	clearmap();
	showall();
}

function clearmap()
{
	if (routeMarkers) 
	{
		for (i in routeMarkers) 
		{
			routeMarkers[i].setMap(null);
		}
	}
	routeMarkers=new Array(0);
	
	if (infowindow)
	{
		infowindow.close();
		infowindow=null; 
	}

	if (clickedMarker)
	{
		clickedMarker.setMap(null);
	}
	
}
	
function saveentry(comments,lat,lng)
{	
	// add the point and name to the database on the server
	xmlbuild=encodeURI("<markers><marker id=\"0\" comments=\""+ comments +"\" lat=\""+ lat +"\" lng=\""+ lng +"\"/></markers>");
	//Create a boolean variable to check for a valid MS instance.
	var xmlhttp = false;
	
	//Check if we are using IE.
	try 
	{
		//If the javascript version is greater than 5.
		xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} 
	catch (e) 
	{
		//If not, then use the older active x object.
		try 
		{
			//If we are using IE.
			xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
		} 
		catch (E) 
		{
			//Else we must be using a non-IE browser.
			xmlhttp = false;
		}
	}
	
	//If we are using a non-IE browser, create a javascript instance of the object.
	if (!xmlhttp && typeof XMLHttpRequest != 'undefined') 
	{
		xmlhttp = new XMLHttpRequest();
	}
	
    xmlhttp.onreadystatechange=function()
	{
		if(xmlhttp.readyState==4)
        {
			var xml = xmlhttp.responseText;
			document.getElementById("msg").innerHTML="<p><img src='images/loading.gif' /><br/>Loading...</p>";
        }
	};
    xmlhttp.open("GET","addgbentries.php?xml="+xmlbuild,true);
	if (debug)
	{
		alert ("addgbentries.php?xml="+xmlbuild);	
	}
    xmlhttp.send(null);	
}
//]]>